"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var decorators_1 = require("hornet-js-test/src/decorators");
var test_run_1 = require("hornet-js-test/src/test-run");
var icon_1 = require("hornet-js-react-components/src/widget/icon/icon");
var hornet_test_assert_1 = require("hornet-js-test/src/hornet-test-assert");
var base_test_1 = require("hornet-js-test/src/base-test");
var React = require("react");
var button_info_accessibilite_1 = require("hornet-js-react-components/src/widget/button/button-info-accessibilite");
var iconElement;
var element;
var IconTest = /** @class */ (function (_super) {
    tslib_1.__extends(IconTest, _super);
    function IconTest() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    IconTest.prototype.beforeEach = function () {
        iconElement = (React.createElement("div", null,
            React.createElement(icon_1.Icon, { title: "Icon1", action: this.monAction, alt: "Icon1", url: "#", src: button_info_accessibilite_1.ButtonInfoAccessibilite.genUrlTheme() + "/img/button/icon_info.svg" }),
            React.createElement(icon_1.Icon, { title: "Icon2", alt: "Icon2", src: button_info_accessibilite_1.ButtonInfoAccessibilite.genUrlTheme() + "/img/button/icon_info.svg" }),
            React.createElement(icon_1.Icon, { title: "Icon3", alt: "Icon3", url: "monTest", src: button_info_accessibilite_1.ButtonInfoAccessibilite.genUrlTheme() + "/img/button/icon_info.svg" })));
    };
    IconTest.prototype.testOk = function () {
        var _this = this;
        element = this.renderIntoDocument(iconElement, this.generateMainId());
        var buttonElements = document.getElementsByTagName("button");
        hornet_test_assert_1.HornetTestAssert.assertEquals(buttonElements.length, 2, "Le DOM doit présenter deux boutons");
        var aElements = document.getElementsByTagName("a");
        hornet_test_assert_1.HornetTestAssert.assertEquals(aElements.length, 1, "Le DOM doit présenter un lien");
        setTimeout(function () {
            _this.triggerMouseEvent(buttonElements[0], "click");
            _this.end();
        }, 250);
    };
    IconTest.prototype.monAction = function () {
        console.log("Action click détectée, le test peut être terminé");
    };
    tslib_1.__decorate([
        decorators_1.Decorators.beforeEach,
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], IconTest.prototype, "beforeEach", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Test OK"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], IconTest.prototype, "testOk", null);
    IconTest = tslib_1.__decorate([
        decorators_1.Decorators.describe("Test Karma Icon")
    ], IconTest);
    return IconTest;
}(base_test_1.BaseTest));
//lancement des Tests
test_run_1.runTest(new IconTest());

//# sourceMappingURL=icon.karma.js.map
