"use strict";
/**
 * Copyright ou © ou Copr. Ministère de l'Europe et des Affaires étrangères (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * Ce logiciel est un programme informatique servant à faciliter la création
 * d'applications Web conformément aux référentiels généraux français : RGI, RGS et RGAA
 * <p/>
 * Ce logiciel est régi par la licence CeCILL soumise au droit français et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffusée par le CEA, le CNRS et l'INRIA
 * sur le site "http://www.cecill.info".
 * <p/>
 * En contrepartie de l'accessibilité au code source et des droits de copie,
 * de modification et de redistribution accordés par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
 * seule une responsabilité restreinte pèse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concédants successifs.
 * <p/>
 * A cet égard  l'attention de l'utilisateur est attirée sur les risques
 * associés au chargement,  à l'utilisation,  à la modification et/ou au
 * développement et à la reproduction du logiciel par l'utilisateur étant
 * donné sa spécificité de logiciel libre, qui peut le rendre complexe à
 * manipuler et qui le réserve donc à des développeurs et des professionnels
 * avertis possédant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
 * logiciel à leurs besoins dans des conditions permettant d'assurer la
 * sécurité de leurs systèmes et ou de leurs données et, plus généralement,
 * à l'utiliser et l'exploiter dans les mêmes conditions de sécurité.
 * <p/>
 * Le fait que vous puissiez accéder à cet en-tête signifie que vous avez
 * pris connaissance de la licence CeCILL, et que vous en avez accepté les
 * termes.
 * <p/>
 * <p/>
 * Copyright or © or Copr. Ministry for Europe and Foreign Affairs (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * This software is a computer program whose purpose is to facilitate creation of
 * web application in accordance with french general repositories : RGI, RGS and RGAA.
 * <p/>
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 * <p/>
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 * <p/>
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 * <p/>
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 *
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
/**
 * hornet-js-react-components - Ensemble des composants web React de base de hornet-js
 *
 * @author MEAE - Ministère de l'Europe et des Affaires étrangères
 * @version v5.2.0
 * @link git+https://github.com/diplomatiegouvfr/hornet-js.git
 * @license CECILL-2.1
 */
var React = require("react");
var hornet_js_utils_1 = require("hornet-js-utils");
var abstract_field_1 = require("hornet-js-react-components/src/widget/form/abstract-field");
var _ = require("lodash");
var picto_1 = require("hornet-js-react-components/src/img/picto");
var classNames = require("classnames");
var event_1 = require("./event");
var hornet_event_1 = require("hornet-js-core/src/event/hornet-event");
var chars_counter_1 = require("hornet-js-react-components/src/widget/form/chars-counter");
var tool_tip_1 = require("hornet-js-react-components/src/widget/tool-tip/tool-tip");
var key_codes_1 = require("hornet-js-components/src/event/key-codes");
var logger = hornet_js_utils_1.Utils.getLogger("hornet-js-react-components.widget.form.textarea-field");
var TextAreaField = /** @class */ (function (_super) {
    tslib_1.__extends(TextAreaField, _super);
    function TextAreaField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @inheritDoc
     */
    TextAreaField.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        return this.state.valued !== nextState.valued
            || this.state.currentValue !== nextState.currentValue
            || this.state.errors !== nextState.errors;
    };
    /**
     * @inheritDoc
     */
    TextAreaField.prototype.componentDidMount = function () {
        this.setMinHeight();
        this.setClientHeight();
    };
    /**
     * Génère le rendu spécifique du champ
     * @returns {any}
     * @override
     */
    TextAreaField.prototype.renderWidget = function () {
        var _this = this;
        var htmlProps = this.getHtmlProps();
        var hasError = this.hasErrors() ? " has-error" : "";
        var charsCounterId = "chars-counter-" + this.state.id;
        _.assign(htmlProps, {
            className: htmlProps["className"] ? htmlProps["className"] + hasError : hasError,
            "role-aria": "textbox",
            "aria-multiline": "true",
            "aria-labelledby": this.state.name + "-span-label " + charsCounterId,
        });
        var classList = {
            "textarea-resizable": (this.props.extendable),
            "textarea-unresizable": (!this.props.extendable)
        };
        var classListStr = classNames(classList);
        _.assign(htmlProps, { className: htmlProps["className"] + " " + classListStr });
        return (React.createElement("div", { className: "textarea-container" },
            React.createElement("textarea", tslib_1.__assign({ onChange: this.valueChange, ref: function (elt) {
                    _this.registerHtmlElement(elt);
                    _this.element = elt;
                } }, htmlProps)),
            this.state.resettable && this.state.valued && !this.state.readOnly && !this.state.disabled ? this.renderResetButton() :
                React.createElement("div", null)));
    };
    /**
     * Surcharge de la méthode de la classe mère pour ajouter la limite autorisée si le nombre de caractères maximum est défini
     * et si la props displayMaxCharInLabel est true
     * @param fieldId
     * @param fieldName
     * @param label
     * @param required
     */
    TextAreaField.prototype.renderLabel = function (fieldId, fieldName, label, required) {
        var _this = this;
        var customLabel = label || "";
        if (this.props.displayMaxCharInLabel && this.props.maxChar) {
            customLabel = customLabel.concat(" ").concat(this.i18n("charsCounter.limitLabel", { maxChar: this.props.maxChar }));
        }
        var urlTheme = this.state.imgFilePath || abstract_field_1.AbstractField.genUrlTheme();
        var urlIcoTooltip = urlTheme + this.state.icoToolTip;
        if (this.state.abbr && !this.state.lang) {
            logger.warn("Field ", fieldName, " Must have lang with abbr configuration");
        }
        var message = this.props.alertMessage || "textarea.alertMessage";
        var charTitle = this.props.alertTitle || "textarea.alertTitle";
        var charLabel = this.props.charLabel || "textarea.charLabel";
        var ariaDescribedby = { "aria-describedby": fieldName + "Tooltip" };
        return (React.createElement("div", { className: this.state.labelClass + " label-container-textarea label-container" },
            this.state.displayCharNumber ?
                React.createElement(chars_counter_1.CharsCounter, { maxChar: this.props.maxChar, elementId: this.state.id, className: "textarea-character-value", tooManyCharsClassName: "textarea-too-many-char", text: this.state.currentValue, charLabel: charLabel, alertMessage: message, showAlert: this.props.showAlert, alertTitle: charTitle, ref: function (elt) {
                        _this.charsCounter = elt;
                    } }) : null,
            React.createElement("label", tslib_1.__assign({ htmlFor: fieldId, id: fieldName + "Label", className: "label-content" }, this.state.toolTip ? ariaDescribedby : null),
                (this.state.abbr) ?
                    React.createElement("abbr", { lang: this.state.lang, title: this.state.abbr },
                        React.createElement("span", { className: "label-abbr", id: fieldName + "-span-label" }, customLabel)) : React.createElement("span", { className: "label", id: fieldName + "-span-label" }, customLabel),
                required && this.state.markRequired ?
                    React.createElement("span", { className: "label-required" },
                        React.createElement("abbr", { title: this.getRequiredLabel() }, "*")) : null,
                this.state.toolTip ?
                    React.createElement(tool_tip_1.ToolTip, { alt: this.state.toolTip, src: urlIcoTooltip, idSpan: fieldName + "Tooltip" }) : null)));
    };
    /**
     * rendu html du bouton reset
     * @returns {any}
     */
    TextAreaField.prototype.renderResetButton = function () {
        var htmlProps = _.cloneDeep(this.getHtmlProps());
        var hidden = htmlProps["type"] === "hidden";
        var classList = {
            "input-reset textarea-reset": true,
            "input-reset-hidden": (!this.isValued() || hidden),
        };
        var aProps = {};
        if (this.isValued()) {
            aProps["onClick"] = this.resetValue;
            aProps["tabIndex"] = 0;
            aProps["title"] = this.i18n(this.state.resetTitle, tslib_1.__assign({}, this.state));
        }
        var identifiant = this.getResetButtonId();
        return (React.createElement("span", { className: classNames(classList), role: "button", "aria-hidden": !this.state.valued, onKeyDown: this.handleResetKeyDown, id: identifiant },
            React.createElement("a", tslib_1.__assign({}, aProps),
                React.createElement("img", { src: picto_1.Picto.grey.close, alt: aProps.title }))));
    };
    TextAreaField.prototype.handleResetKeyDown = function (e) {
        var key = e.keyCode;
        if (key === key_codes_1.KeyCodes.ENTER || key === key_codes_1.KeyCodes.SPACEBAR) {
            e.preventDefault();
            e.stopPropagation();
            this.resetValue();
            this.htmlElement.focus();
        }
    };
    TextAreaField.prototype.getResetButtonId = function () {
        return this.props.id || this.props.name + "ResetButton";
    };
    TextAreaField.prototype.setMinHeight = function () {
        this.minHeight = this.element.clientHeight;
    };
    /**
     * règle la taille du textarea en fonction du texte présent à l'intérieur de celui ci
     * @param event
     */
    TextAreaField.prototype.setClientHeight = function (event) {
        if (this.props.extendable) {
            var text = event ? event.target.value : this.element.textContent;
            if (text !== undefined && text !== null) {
                var height = (text.split("\n").length + 1) * 25;
                var finalHeight = this.props.maxLength && this.props.maxLength < this.state.height ? this.props.maxLength : height;
                finalHeight = (finalHeight < this.minHeight) ? this.minHeight : finalHeight;
                this.element.style.height = finalHeight + "px";
                this.element.height = finalHeight;
                // recalcul de la hauteur à l'aide de la taille du scroll
                var elem = document.getElementById(this.element.id);
                var elemheight = elem.height;
                // cas de lapparition du scroll
                while (elemheight < this.element.scrollHeight) {
                    elemheight = elemheight + 25;
                }
                var elemFinalHeight = (this.props.maxLength && this.props.maxLength < this.state.height)
                    ? this.props.maxLength
                    : elemheight;
                elemFinalHeight = (elemFinalHeight < this.minHeight) ? this.minHeight : elemFinalHeight;
                elem.style.height = elemFinalHeight + "px";
                elem.height = elemFinalHeight;
            }
        }
        else {
            // Cas d'un textarea pouvant avoir un scrollbar
            var elem = document.getElementById(this.element.id);
            var resetElement = document.getElementById(this.getResetButtonId());
            if (elem.clientHeight < this.element.scrollHeight && resetElement) {
                if (resetElement.className.indexOf("textarea-reset-scrollbar") < 0) {
                    resetElement.className = resetElement.className.replace("textarea-reset", "textarea-reset-scrollbar");
                }
            }
            else if (resetElement) {
                if (resetElement.className.indexOf("textarea-reset-scrollbar") > 0) {
                    resetElement.className = resetElement.className.replace("textarea-reset-scrollbar", "textarea-reset");
                }
            }
        }
    };
    /**
     * Calcule si le champs à une valeur ou non
     * @param event
     */
    TextAreaField.prototype.valueChange = function (event) {
        // if (this.state.extendable) {
        this.setClientHeight(event);
        // }
        // mise à jour du texte d'affichage du nombre de caractère
        var value = event.target.value;
        // Empêcher la propagation de l'évènement pour ne pas que la modale se ferme systématiquement
        // lorsque le event.target.value est 32 (touche espace).
        // affichage de l'alerte
        event.stopPropagation();
        if (value) {
            this.setState({ valued: true, currentValue: value });
        }
        else if (!value && this.state.valued) {
            this.setState({ valued: false, currentValue: value });
        }
        if (this.charsCounter) {
            this.charsCounter.handleTextChange(value);
        }
    };
    /**
     * Surcharge de la méthode
     * @param value
     * @returns {InputField}
     */
    TextAreaField.prototype.setCurrentValue = function (value) {
        _super.prototype.setCurrentValue.call(this, value);
        this.setState({ valued: (value !== "" && value), currentValue: value });
        if (this.charsCounter) {
            this.charsCounter.handleTextChange(value);
        }
        this.setClientHeight();
        return this;
    };
    /**
     * teste si le champs n'est pas vide
     * @returns {boolean|any}
     */
    TextAreaField.prototype.isValued = function () {
        return this.state.valued || this.props.value;
    };
    /**
     * Permet de rendre à null la valeur du champ
     */
    TextAreaField.prototype.resetValue = function () {
        var _this = this;
        if (this.htmlElement && this.htmlElement.onchange) {
            this.htmlElement.onchange();
        }
        this.htmlElement.value = "";
        hornet_event_1.fireHornetEvent(event_1.VALUE_CHANGED_EVENT.withData(this.htmlElement));
        this.charsCounter.handleTextChange(null);
        this.setState({ valued: false, currentValue: undefined }, function () {
            _this.setClientHeight();
        });
    };
    TextAreaField.defaultProps = _.assign(_.cloneDeep(abstract_field_1.AbstractField.defaultProps), {
        rows: 6,
        resettable: true,
        displayCharNumber: true,
        extendable: true,
        showAlert: true,
        resetTitle: "textarea.resetTitle",
    });
    return TextAreaField;
}(abstract_field_1.AbstractField));
exports.TextAreaField = TextAreaField;

//# sourceMappingURL=textarea-field.js.map
