"use strict";
/**
 * Copyright ou © ou Copr. Ministère de l'Europe et des Affaires étrangères (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * Ce logiciel est un programme informatique servant à faciliter la création
 * d'applications Web conformément aux référentiels généraux français : RGI, RGS et RGAA
 * <p/>
 * Ce logiciel est régi par la licence CeCILL soumise au droit français et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffusée par le CEA, le CNRS et l'INRIA
 * sur le site "http://www.cecill.info".
 * <p/>
 * En contrepartie de l'accessibilité au code source et des droits de copie,
 * de modification et de redistribution accordés par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
 * seule une responsabilité restreinte pèse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concédants successifs.
 * <p/>
 * A cet égard  l'attention de l'utilisateur est attirée sur les risques
 * associés au chargement,  à l'utilisation,  à la modification et/ou au
 * développement et à la reproduction du logiciel par l'utilisateur étant
 * donné sa spécificité de logiciel libre, qui peut le rendre complexe à
 * manipuler et qui le réserve donc à des développeurs et des professionnels
 * avertis possédant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
 * logiciel à leurs besoins dans des conditions permettant d'assurer la
 * sécurité de leurs systèmes et ou de leurs données et, plus généralement,
 * à l'utiliser et l'exploiter dans les mêmes conditions de sécurité.
 * <p/>
 * Le fait que vous puissiez accéder à cet en-tête signifie que vous avez
 * pris connaissance de la licence CeCILL, et que vous en avez accepté les
 * termes.
 * <p/>
 * <p/>
 * Copyright or © or Copr. Ministry for Europe and Foreign Affairs (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * This software is a computer program whose purpose is to facilitate creation of
 * web application in accordance with french general repositories : RGI, RGS and RGAA.
 * <p/>
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 * <p/>
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 * <p/>
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 * <p/>
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 *
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var test_run_1 = require("hornet-js-test/src/test-run");
var decorators_1 = require("hornet-js-test/src/decorators");
var chai = require('chai');
var expect = chai.expect;
var React = require("react");
var assert = require("assert");
var datasource_1 = require("hornet-js-core/src/component/datasource/datasource");
var auto_complete_multi_field_1 = require("hornet-js-react-components/src/widget/form/auto-complete-multi-field");
var hornet_react_test_1 = require("hornet-js-test/src/hornet-react-test");
var dataSource;
var element;
var autocomplete;
var AutoCompleteMultiFieldTest = /** @class */ (function (_super) {
    tslib_1.__extends(AutoCompleteMultiFieldTest, _super);
    function AutoCompleteMultiFieldTest() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AutoCompleteMultiFieldTest.prototype.beforeEach = function () {
        var data = [];
        for (var i = 1; i < 50; i++) {
            data.push({ id: i, label: "libelle" + i });
        }
        dataSource = new datasource_1.DataSource(data, { value: "id", text: "label" });
        element = (React.createElement(auto_complete_multi_field_1.AutoCompleteMultiField, { dataSource: dataSource, maxHeight: 200, name: "civilite", label: "civilite", required: true, labelKey: "libelle", valueKey: "id", noResultLabel: "test" }));
    };
    ;
    AutoCompleteMultiFieldTest.prototype.testOk = function () {
        assert.equal(1, 1);
        this.end();
    };
    ;
    AutoCompleteMultiFieldTest.prototype.testselect = function () {
        var _this = this;
        var index = 0;
        var items = [];
        dataSource.on("select", function (result) {
            if (result && result.length > 0) {
                index++;
                items.push(index);
                items.forEach(function (item, ind) {
                    expect(_.isEqual(dataSource.selected[ind].value, item)).to.be.true;
                });
                if (index == dataSource.results.length - 1)
                    _this.end();
            }
        });
        autocomplete = this.renderIntoDocument(element, "main1");
        dataSource.on("fetch", function () {
            document.querySelector("#civilite").click();
            var elts = document.querySelectorAll("#main1 .autocomplete-item");
            dataSource.results.forEach(function (value, index) {
                _this.triggerMouseEvent(elts[index], "mousedown");
            });
        });
        dataSource.reload();
    };
    ;
    AutoCompleteMultiFieldTest.prototype.testNoResultLabel = function () {
        var _this = this;
        var data = [];
        for (var i = 1; i < 50; i++) {
            data.push({ id: i, label: "libelle" + i });
        }
        dataSource = new datasource_1.DataSource([], { value: "id", text: "label" });
        autocomplete = this.renderIntoDocument(element, "main2");
        dataSource.on("add", function () {
            var element = document.querySelector("#main2 #civilite");
            setTimeout(function () {
                _this.triggerFocusOnElement(element);
                _this.triggerKeydownEvent(element, "m", 77, true);
                setTimeout(function () {
                    _this.triggerKeydownEvent(element, "a", 65, true);
                    setTimeout(function () {
                        _this.triggerKeydownEvent(element, "d", 68, true);
                        setTimeout(function () {
                            _this.triggerKeydownEvent(element, "i", 73, true);
                            setTimeout(function () {
                                _this.triggerKeydownEvent(element, "d", 68, true);
                                expect(document.querySelector('#main2 ul.autocomplete-selector-list div').innerHTML).to.be.equal("test");
                                _this.end();
                            }, 250);
                        }, 250);
                    }, 250);
                }, 250);
            }, 250);
        });
        dataSource.add(true, data);
    };
    ;
    tslib_1.__decorate([
        decorators_1.Decorators.beforeEach,
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], AutoCompleteMultiFieldTest.prototype, "beforeEach", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Test OK"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], AutoCompleteMultiFieldTest.prototype, "testOk", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("selectionner un element dans l'autocomplete multiple"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], AutoCompleteMultiFieldTest.prototype, "testselect", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("test la surchage du label"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], AutoCompleteMultiFieldTest.prototype, "testNoResultLabel", null);
    AutoCompleteMultiFieldTest = tslib_1.__decorate([
        decorators_1.Decorators.describe("Test Karma auto-complete-multi-field")
    ], AutoCompleteMultiFieldTest);
    return AutoCompleteMultiFieldTest;
}(hornet_react_test_1.HornetReactTest));
;
//lancement des Tests
test_run_1.runTest(new AutoCompleteMultiFieldTest());

//# sourceMappingURL=auto-complete-field.multi.select.test.karma.js.map
