"use strict";
/**
 * Copyright ou © ou Copr. Ministère de l'Europe et des Affaires étrangères (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * Ce logiciel est un programme informatique servant à faciliter la création
 * d'applications Web conformément aux référentiels généraux français : RGI, RGS et RGAA
 * <p/>
 * Ce logiciel est régi par la licence CeCILL soumise au droit français et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffusée par le CEA, le CNRS et l'INRIA
 * sur le site "http://www.cecill.info".
 * <p/>
 * En contrepartie de l'accessibilité au code source et des droits de copie,
 * de modification et de redistribution accordés par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
 * seule une responsabilité restreinte pèse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concédants successifs.
 * <p/>
 * A cet égard  l'attention de l'utilisateur est attirée sur les risques
 * associés au chargement,  à l'utilisation,  à la modification et/ou au
 * développement et à la reproduction du logiciel par l'utilisateur étant
 * donné sa spécificité de logiciel libre, qui peut le rendre complexe à
 * manipuler et qui le réserve donc à des développeurs et des professionnels
 * avertis possédant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
 * logiciel à leurs besoins dans des conditions permettant d'assurer la
 * sécurité de leurs systèmes et ou de leurs données et, plus généralement,
 * à l'utiliser et l'exploiter dans les mêmes conditions de sécurité.
 * <p/>
 * Le fait que vous puissiez accéder à cet en-tête signifie que vous avez
 * pris connaissance de la licence CeCILL, et que vous en avez accepté les
 * termes.
 * <p/>
 * <p/>
 * Copyright or © or Copr. Ministry for Europe and Foreign Affairs (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * This software is a computer program whose purpose is to facilitate creation of
 * web application in accordance with french general repositories : RGI, RGS and RGAA.
 * <p/>
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 * <p/>
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 * <p/>
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 * <p/>
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 *
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
/**
 * hornet-js-react-components - Ensemble des composants web React de base de hornet-js
 *
 * @author MEAE - Ministère de l'Europe et des Affaires étrangères
 * @version v5.2.0
 * @link git+https://github.com/diplomatiegouvfr/hornet-js.git
 * @license CECILL-2.1
 */
var hornet_react_test_1 = require("hornet-js-test/src/hornet-react-test");
var test_run_1 = require("hornet-js-test/src/test-run");
var decorators_1 = require("hornet-js-test/src/decorators");
var React = require("react");
var assert = require("assert");
var chai_1 = require("chai");
var chars_counter_1 = require("hornet-js-react-components/src/widget/form/chars-counter");
var messages = require("hornet-js-core/src/i18n/hornet-messages-components.json");
var hornet_js_utils_1 = require("hornet-js-utils");
var element;
var charsCounterElement, charsCounterElementWithoutAlert;
var CharsCounterTest = /** @class */ (function (_super) {
    tslib_1.__extends(CharsCounterTest, _super);
    function CharsCounterTest() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CharsCounterTest.prototype.beforeEach = function () {
        var _this = this;
        hornet_js_utils_1.Utils.setCls("hornet.internationalization", { messages: messages });
        charsCounterElement = (React.createElement(chars_counter_1.CharsCounter, { alertMessage: "Le nombre de caract\u00E8res saisi {count} d\u00E9passe le maximum {maxChar}", alertTitle: "Max char titre", charLabel: "{count, plural, =0 {0 caract\u00E8re} =1 {1 caract\u00E8re} other {# caract\u00E8res}}", showAlert: true, maxChar: 20, className: "normal", tooManyCharsClassName: "limite-depassee", elementId: "id", text: "Hello world!", ref: function (elt) { _this.charsCounterRef = elt; } }));
        charsCounterElementWithoutAlert = (React.createElement(chars_counter_1.CharsCounter, { showAlert: false, maxChar: 20, charLabel: "{count, plural, =0 {0 caract\u00E8re} =1 {1 caract\u00E8re} other {# caract\u00E8res}}", className: "normal", tooManyCharsClassName: "limite-depassee", elementId: "id1", text: "Unybnezfyhbhzbhuaaaaa", ref: function (elt) { _this.charsCounterRef = elt; } }));
    };
    CharsCounterTest.prototype.testOk = function () {
        assert.equal(1, 1);
        this.end();
    };
    CharsCounterTest.prototype.testCharsCounter = function () {
        var id = this.generateMainId();
        element = this.renderIntoDocument(charsCounterElement, id);
        var charsCounter = document.querySelector("#" + id + " #chars-counter-id");
        chai_1.expect(charsCounter).to.exist;
        chai_1.expect(charsCounter.innerHTML).to.equals("12 caractères");
        chai_1.expect(charsCounter.hasAttribute("class")).to.be.true;
        chai_1.expect(charsCounter.getAttribute("class")).to.be.equals("normal");
        this.end();
    };
    CharsCounterTest.prototype.testCharsCounterWithChangeText = function () {
        var _this = this;
        var id = this.generateMainId();
        element = this.renderIntoDocument(charsCounterElement, id);
        var charsCounter = document.querySelector("#" + id + " #chars-counter-id");
        chai_1.expect(charsCounter).to.exist;
        this.charsCounterRef.handleTextChange("sdjnfjioskcnuilnqze12");
        setTimeout(function () {
            chai_1.expect(charsCounter.innerHTML).to.equals("21 caractères");
            chai_1.expect(charsCounter.hasAttribute("class")).to.be.true;
            chai_1.expect(charsCounter.getAttribute("class")).to.be.equals("normal limite-depassee");
            var alert = document.querySelector(".widget-alert-body");
            chai_1.expect(alert).to.exist;
            var alertOk = document.querySelector(".widget-dialogue-footer #alertOK");
            var alertTitle = document.querySelector(".widget-dialogue-title h1");
            var alertBody = document.querySelector(".widget-alert-body");
            chai_1.expect(alertOk).to.exist;
            chai_1.expect(alertTitle).to.exist;
            chai_1.expect(alertTitle.innerText).to.be.equals("Max char titre");
            chai_1.expect(alertBody).to.exist;
            chai_1.expect(alertBody.innerText).to.be.equals("Le nombre de caractères saisi 21 dépasse le maximum 20");
            alertOk.click();
            _this.end();
        }, 250);
    };
    CharsCounterTest.prototype.charsCounterWithoutAlert = function () {
        var _this = this;
        var id = this.generateMainId();
        element = this.renderIntoDocument(charsCounterElementWithoutAlert, id);
        var charsCounter = document.querySelector("#" + id + " #chars-counter-id1");
        chai_1.expect(charsCounter).to.exist;
        setTimeout(function () {
            chai_1.expect(charsCounter.innerHTML).to.equals("21 caractères");
            chai_1.expect(charsCounter.hasAttribute("class")).to.be.true;
            chai_1.expect(charsCounter.getAttribute("class")).to.be.equals("normal limite-depassee");
            var alert = document.querySelector(".widget-alert-body");
            chai_1.expect(alert).to.not.exist;
            _this.end();
        }, 250);
    };
    tslib_1.__decorate([
        decorators_1.Decorators.beforeEach,
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], CharsCounterTest.prototype, "beforeEach", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Test OK"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], CharsCounterTest.prototype, "testOk", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Affichage charsCounter limite pas dépassée"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], CharsCounterTest.prototype, "testCharsCounter", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Affichage charsCounter limite dépassée"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], CharsCounterTest.prototype, "testCharsCounterWithChangeText", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Affichage charsCounter limite dépassée sans alert"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], CharsCounterTest.prototype, "charsCounterWithoutAlert", null);
    CharsCounterTest = tslib_1.__decorate([
        decorators_1.Decorators.describe("Test Karma charsCounter")
    ], CharsCounterTest);
    return CharsCounterTest;
}(hornet_react_test_1.HornetReactTest));
// lancement des Tests
test_run_1.runTest(new CharsCounterTest());

//# sourceMappingURL=chars-counter.test.karma.js.map
