"use strict";
/**
 * Copyright ou © ou Copr. Ministère de l'Europe et des Affaires étrangères (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * Ce logiciel est un programme informatique servant à faciliter la création
 * d'applications Web conformément aux référentiels généraux français : RGI, RGS et RGAA
 * <p/>
 * Ce logiciel est régi par la licence CeCILL soumise au droit français et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffusée par le CEA, le CNRS et l'INRIA
 * sur le site "http://www.cecill.info".
 * <p/>
 * En contrepartie de l'accessibilité au code source et des droits de copie,
 * de modification et de redistribution accordés par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
 * seule une responsabilité restreinte pèse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concédants successifs.
 * <p/>
 * A cet égard  l'attention de l'utilisateur est attirée sur les risques
 * associés au chargement,  à l'utilisation,  à la modification et/ou au
 * développement et à la reproduction du logiciel par l'utilisateur étant
 * donné sa spécificité de logiciel libre, qui peut le rendre complexe à
 * manipuler et qui le réserve donc à des développeurs et des professionnels
 * avertis possédant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
 * logiciel à leurs besoins dans des conditions permettant d'assurer la
 * sécurité de leurs systèmes et ou de leurs données et, plus généralement,
 * à l'utiliser et l'exploiter dans les mêmes conditions de sécurité.
 * <p/>
 * Le fait que vous puissiez accéder à cet en-tête signifie que vous avez
 * pris connaissance de la licence CeCILL, et que vous en avez accepté les
 * termes.
 * <p/>
 * <p/>
 * Copyright or © or Copr. Ministry for Europe and Foreign Affairs (2017)
 * <p/>
 * pole-architecture.dga-dsi-psi@diplomatie.gouv.fr
 * <p/>
 * This software is a computer program whose purpose is to facilitate creation of
 * web application in accordance with french general repositories : RGI, RGS and RGAA.
 * <p/>
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 * <p/>
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 * <p/>
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 * <p/>
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 *
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
/**
 * hornet-js-react-components - Ensemble des composants web React de base de hornet-js
 *
 * @author MEAE - Ministère de l'Europe et des Affaires étrangères
 * @version v5.2.0
 * @link git+https://github.com/diplomatiegouvfr/hornet-js.git
 * @license CECILL-2.1
 */
var hornet_react_test_1 = require("hornet-js-test/src/hornet-react-test");
var test_run_1 = require("hornet-js-test/src/test-run");
var decorators_1 = require("hornet-js-test/src/decorators");
var React = require("react");
var assert = require("assert");
var chai_1 = require("chai");
var input_field_1 = require("hornet-js-react-components/src/widget/form/input-field");
var form_1 = require("hornet-js-react-components/src/widget/form/form");
var messages = require("hornet-js-core/src/i18n/hornet-messages-components.json");
var hornet_js_utils_1 = require("hornet-js-utils");
var elementBase, elementWithValue, elementWithValueEtCompteur;
var $element;
var count = 0;
var InputFieldTest = /** @class */ (function (_super) {
    tslib_1.__extends(InputFieldTest, _super);
    function InputFieldTest() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    InputFieldTest.prototype.beforeEach = function () {
        var _this = this;
        hornet_js_utils_1.Utils.setCls("hornet.internationalization", { messages: messages });
        count++;
        elementBase = (React.createElement(input_field_1.InputField, { name: "prenom", id: "prenom", label: "prénom", required: true, requiredLabel: "Pr\u00E9nom obligatoire", maxLength: 50, resettable: true }));
        elementWithValue = (React.createElement(form_1.Form, { id: "id-form-" + count, defaultValues: { prenom: "test" } },
            React.createElement(input_field_1.InputField, { name: "prenom", id: "prenom", label: "prénom", required: true, requiredLabel: "Pr\u00E9nom obligatoire", maxLength: 50, resettable: true, maxChar: 25 })));
        elementWithValueEtCompteur = (React.createElement(input_field_1.InputField, { name: "nom", ref: function (elt) { _this.inputField = elt; }, id: "nom", label: "Nom", required: true, requiredLabel: "Pr\u00E9nom obligatoire", maxLength: 50, resettable: true, maxChar: 25, displayMaxCharInLabel: true, displayCharNumber: true, showAlert: true }));
    };
    ;
    InputFieldTest.prototype.testOk = function () {
        assert.equal(1, 1);
        this.end();
    };
    ;
    InputFieldTest.prototype.testInput = function () {
        $element = this.renderIntoDocument(elementBase, "main1");
        chai_1.expect(document.querySelector('#main1 #prenom'), "Problème élément Input non trouvé").to.exist;
        this.end();
    };
    ;
    InputFieldTest.prototype.testNoResetButton = function () {
        $element = this.renderIntoDocument(elementBase, "main2");
        chai_1.expect(document.querySelector('#main2 #prenomResetButton.input-reset.input-reset-hidden'), "bouton reset trouvé").to.not.exist;
        this.end();
    };
    ;
    InputFieldTest.prototype.testResetButton = function () {
        $element = this.renderIntoDocument(elementWithValue, "main3");
        chai_1.expect(document.querySelector("#main3 #prenomResetButton.input-reset"), "bouton reset non trouvé").to.exist;
        this.end();
    };
    InputFieldTest.prototype.testReverseLabel = function () {
        var _this = this;
        var elementWithReverseLabel = (React.createElement(input_field_1.InputField, { name: "testReverseLabel", label: "testReverseLabel", reverseLabel: true }));
        var id = this.generateMainId();
        this.renderIntoDocument(elementWithReverseLabel, id);
        setTimeout(function () {
            chai_1.expect(document.querySelector("#" + id + " .abstractfield-container-reverse-label")).to.exist;
            _this.end();
        }, 250);
    };
    InputFieldTest.prototype.testCharsCounter = function () {
        var _this = this;
        $element = this.renderIntoDocument(elementWithValueEtCompteur, "main400");
        var inputNom = document.querySelector("#main400 #nom");
        this.triggerKeydownEvent(inputNom, "m", 77, true);
        setTimeout(function () {
            var charLabel = document.querySelector("#main400 .chars-counter");
            chai_1.expect(charLabel).to.exist;
            chai_1.expect(charLabel.innerHTML).to.equals("1 caractère");
            _this.end();
        }, 250);
    };
    InputFieldTest.prototype.testCharsCounterWithSetCurrentValue = function () {
        var _this = this;
        $element = this.renderIntoDocument(elementWithValueEtCompteur, "main401");
        this.inputField.setCurrentValue("Malam");
        var charLabel = document.querySelector("#main401 .chars-counter");
        setTimeout(function () {
            chai_1.expect(charLabel).to.exist;
            chai_1.expect(charLabel.innerHTML).to.equals("5 caractères");
            chai_1.expect(charLabel.className).to.be.equals("chars-counter");
            _this.end();
        }, 250);
    };
    InputFieldTest.prototype.testCharsCounterWithAlertWithSetCurrentValue = function () {
        var _this = this;
        $element = this.renderIntoDocument(elementWithValueEtCompteur, "main402");
        this.inputField.setCurrentValue("Adria moratizna zenimaheri");
        var charLabel = document.querySelector("#main402 .chars-counter");
        setTimeout(function () {
            chai_1.expect(charLabel.innerHTML).to.be.equal("26 caractères");
            chai_1.expect(charLabel.className).to.be.equals("chars-counter chars-counter-too-many-char");
            var alert = document.querySelector(".widget-alert-body");
            chai_1.expect(alert).to.exist;
            var alertOk = document.querySelector(".widget-dialogue-footer #alertOK");
            var alertTitle = document.querySelector(".widget-dialogue-title h1");
            var alertBody = document.querySelector(".widget-alert-body");
            chai_1.expect(alertOk).to.exist;
            chai_1.expect(alertTitle).to.exist;
            chai_1.expect(alertTitle.innerText).to.be.equals("Nombre de caractères trop élevé");
            chai_1.expect(alertBody).to.exist;
            chai_1.expect(alertBody.innerText).to.be.equals("Le nombre de caractères renseignés est trop élevé par rapport au nombre maximum (26/25).");
            alertOk.click();
            _this.end();
        }, 250);
    };
    InputFieldTest.prototype.testAffichageAlert = function () {
        var _this = this;
        $element = this.renderIntoDocument(elementWithValueEtCompteur, "main403");
        var inputNom = document.querySelector("#main403 #nom");
        var i;
        for (i = 0; i < 26; i++) {
            this.triggerKeydownEvent(inputNom, "m", 77, true);
        }
        var charLabel = document.querySelector("#main403 .chars-counter");
        setTimeout(function () {
            chai_1.expect(charLabel.innerHTML).to.be.equal("26 caractères");
            var alert = document.querySelector(".widget-alert-body");
            chai_1.expect(alert).to.exist;
            var alertOk = document.querySelector(".widget-dialogue-footer #alertOK");
            var alertTitle = document.querySelector(".widget-dialogue-title h1");
            var alertBody = document.querySelector(".widget-alert-body");
            chai_1.expect(alertOk).to.exist;
            chai_1.expect(alertTitle).to.exist;
            chai_1.expect(alertTitle.innerText).to.be.equals("Nombre de caractères trop élevé");
            chai_1.expect(alertBody).to.exist;
            chai_1.expect(alertBody.innerText).to.be.equals("Le nombre de caractères renseignés est trop élevé par rapport au nombre maximum (26/25).");
            alertOk.click();
            _this.end();
        }, 250);
    };
    InputFieldTest.prototype.testNoCharsCount = function () {
        var _this = this;
        $element = this.renderIntoDocument(elementWithValue, "main404");
        var inputPrenom = document.querySelector("#main404 #prenom");
        var i;
        for (i = 0; i < 30; i++) {
            this.triggerKeydownEvent(inputPrenom, "m", 77, true);
        }
        setTimeout(function () {
            var charLabel = document.querySelector("#main404 .chars-counter");
            chai_1.expect(inputPrenom.hasAttribute("aria-labelledby")).to.be.true;
            chai_1.expect(inputPrenom.getAttribute("aria-labelledby")).to.be.equals("prenom-span-label");
            chai_1.expect(charLabel).to.be.null;
            _this.end();
        }, 250);
    };
    InputFieldTest.prototype.testShowAlertWithEspaceInLastPosition = function () {
        var _this = this;
        $element = this.renderIntoDocument(elementWithValueEtCompteur, "main405");
        var inputNom = document.querySelector("#main405 #nom");
        var charLabel = document.querySelector("#main405 .chars-counter");
        var i;
        for (i = 0; i < 25; i++) {
            this.triggerKeydownEvent(inputNom, "m", 77, true);
        }
        this.triggerKeydownEvent(inputNom, " ", 32, true);
        setTimeout(function () {
            chai_1.expect(charLabel.innerHTML).to.be.equal("26 caractères");
            var alert = document.querySelector(".widget-alert-body");
            chai_1.expect(alert).to.exist;
            var alertOk = document.querySelector(".widget-dialogue-footer #alertOK");
            chai_1.expect(alertOk).to.exist;
            alertOk.click();
            _this.end();
        }, 250);
    };
    InputFieldTest.prototype.testLabelWithoutMaxChar = function () {
        var _this = this;
        $element = this.renderIntoDocument(elementBase, "main406");
        var label = document.querySelector("#main406 .label");
        setTimeout(function () {
            chai_1.expect(label.innerHTML).to.be.equal("prénom");
            _this.end();
        }, 250);
    };
    InputFieldTest.prototype.testLabelWithMaxChar = function () {
        var _this = this;
        $element = this.renderIntoDocument(elementWithValueEtCompteur, "main407");
        var label = document.querySelector("#main407 .label");
        setTimeout(function () {
            chai_1.expect(label.innerHTML).to.be.equal("Nom (limite 25 caractères)");
            _this.end();
        }, 250);
    };
    InputFieldTest.prototype.testAriaAttributes = function () {
        var _this = this;
        $element = this.renderIntoDocument(elementWithValueEtCompteur, "main408");
        var inputNom = document.querySelector("#main408 #nom");
        var charLabel = document.querySelector("#main408 .chars-counter");
        setTimeout(function () {
            chai_1.expect(inputNom.hasAttribute("aria-labelledby")).to.be.true;
            chai_1.expect(inputNom.getAttribute("aria-labelledby")).to.be.equals("nom-span-label chars-counter-nom");
            chai_1.expect(charLabel.hasAttribute("role")).to.be.true;
            chai_1.expect(charLabel.getAttribute("role")).to.be.equals("log");
            _this.end();
        }, 250);
    };
    tslib_1.__decorate([
        decorators_1.Decorators.beforeEach,
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], InputFieldTest.prototype, "beforeEach", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it('Test OK'),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], InputFieldTest.prototype, "testOk", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Vérifier l'existence du champ Input"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], InputFieldTest.prototype, "testInput", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Vérifier la non existence du bouton reset lorsqu'un champ est vide"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], InputFieldTest.prototype, "testNoResetButton", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Vérifier l'existence du bouton reset lorsqu'un champ est valorisé"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], InputFieldTest.prototype, "testResetButton", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Test reverseLabel"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], InputFieldTest.prototype, "testReverseLabel", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Test du compte de caractère"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], InputFieldTest.prototype, "testCharsCounter", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Test du compte de caractère avec setCurrentValue"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], InputFieldTest.prototype, "testCharsCounterWithSetCurrentValue", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Test de l'affichage de l'alerte avec setCurrentValue"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], InputFieldTest.prototype, "testCharsCounterWithAlertWithSetCurrentValue", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Test de l'affichage de l'alerte avec setCurrentValue"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], InputFieldTest.prototype, "testAffichageAlert", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Test de non activation du compteur"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], InputFieldTest.prototype, "testNoCharsCount", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Test de l'activation de l'alerte si dernier caractere est espace"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], InputFieldTest.prototype, "testShowAlertWithEspaceInLastPosition", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Test de l'affichage du label sans maxChar"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], InputFieldTest.prototype, "testLabelWithoutMaxChar", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Test de l'affichage du label avec maxChar"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], InputFieldTest.prototype, "testLabelWithMaxChar", null);
    tslib_1.__decorate([
        decorators_1.Decorators.it("Test des attributs RGAA"),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", []),
        tslib_1.__metadata("design:returntype", void 0)
    ], InputFieldTest.prototype, "testAriaAttributes", null);
    InputFieldTest = tslib_1.__decorate([
        decorators_1.Decorators.describe('Test Karma InputField')
    ], InputFieldTest);
    return InputFieldTest;
}(hornet_react_test_1.HornetReactTest));
// lancement des Tests
test_run_1.runTest(new InputFieldTest());

//# sourceMappingURL=input-field.test.karma.js.map
